Index: jobvista-frontend/src/App.js
===================================================================
--- jobvista-frontend/src/App.js	(revision b2488107b82c95e4bdfdfd18b76b44f023786601)
+++ jobvista-frontend/src/App.js	(revision befb98800bd9171fa5ce8a5f29287e549f0ff5aa)
@@ -4,10 +4,12 @@
 import {BrowserRouter} from "react-router-dom";
 import {Header} from "./views/static/Header";
-import {RoutesConfig} from "./auth/RoutesConfig";
-import {useEffect, useState} from "react";
+import RoutesConfig from "./auth/RoutesConfig";
+import React, {useEffect, useState} from "react";
 import {AuthActions} from "./redux/actions/authActions";
 import {AUTH_TOKEN} from "./axios/axiosInstance";
 import {jwtDecode} from "jwt-decode";
 import {NoAccess} from "./views/static/NoAccess";
+import {Loading} from "./views/static/Loading";
+import {ToastContainer} from "react-toastify";
 
 function App() {
@@ -20,5 +22,17 @@
     const [user, setUser] = useState(null);
     const [loading, setLoading] = useState(true);
+    const [minimumLoadingTime, setMinimumLoadingTime] = useState(true);
+
     const auth = useSelector(state => state.auth);
+
+    useEffect(() => {
+        // Simulate a minimum loading time of 1 second
+        const timer = setTimeout(() => {
+            setMinimumLoadingTime(false);
+        }, 1000);
+
+        // Clear timeout if component unmounts
+        return () => clearTimeout(timer);
+    }, []);
 
     useEffect(() => {
@@ -30,5 +44,6 @@
                     name: decodedToken.name,
                     role: decodedToken.role,
-                    hasAccess: auth.currentUser.access,
+                    hasAccess: decodedToken.access,
+                    id: decodedToken.id
                 });
                 setLoading(false);
@@ -42,6 +57,6 @@
     }, [auth]);
 
-    if (loading) {
-        return <NoAccess />; // Replace LoadingSpinner with your loading indicator component
+    if (loading || minimumLoadingTime) {
+        return <Loading />; // Replace LoadingSpinner with your loading indicator component
     }
 
@@ -58,11 +73,11 @@
                       <Header />
                       <RoutesConfig />
+                      {/*<Loading/>*/}
                   </>
               ) : (
                   <NoAccess user={user}/>
               )}
-
-
           </BrowserRouter>
+          <ToastContainer/>
       </div>
   );
Index: jobvista-frontend/src/auth/RoutesConfig.js
===================================================================
--- jobvista-frontend/src/auth/RoutesConfig.js	(revision b2488107b82c95e4bdfdfd18b76b44f023786601)
+++ jobvista-frontend/src/auth/RoutesConfig.js	(revision befb98800bd9171fa5ce8a5f29287e549f0ff5aa)
@@ -1,31 +1,212 @@
-
-import {Route, Router, Routes} from 'react-router-dom'
+import {Navigate, Route, Router, Routes} from 'react-router-dom'
 import {Dashboard} from "../views/dashboard/Dashboard";
 import {SignInForm} from "../views/auth/SignInForm";
 import {SignUpRecruiterForm} from "../views/auth/SignUpRecruiterForm";
 import {SignUpJobSeekerForm} from "../views/auth/SignUpJobSeekerForm";
-import {JobAdvertisements} from "../views/job_advertisements/JobAdvertisements";
+import {Workspace} from "../views/job_advertisements/RecruiterWorkspace";
 import {JobAdDetails} from "../views/job_advertisements/JobAdDetails";
 import {ApplicationsByJobAd} from "../views/applications/ApplicationsByJobAd";
 import {ApplicationsByJobSeeker} from "../views/applications/ApplicationsByJobSeeker";
+
+import {AdminPanel} from "../views/admin_panel/AdminPanel";
+import {RecruiterProfile} from "../views/recruiters/RecruiterProfile";
+import {AboutUs} from "../views/static/AboutUs";
+import {JobSeekerEditProfile} from "../views/edit_profile/JobSeekerEditProfile";
+import {RecruiterEditProfile} from "../views/edit_profile/RecruiterEditProfile";
+import Roles from "../enumerations/Roles";
+import {useSelector} from "react-redux";
 import {useEffect, useState} from "react";
-import {AUTH_TOKEN} from "../axios/axiosInstance";
-import {jwtDecode} from "jwt-decode";
-import {useSelector} from "react-redux";
-import {AdminPanel} from "../views/admin_panel/AdminPanel";
-export const RoutesConfig = () => {
+import {ErrorPage} from "../views/static/ErrorPage";
+
+export const PrivateRoutes = [
+    {
+        component: AdminPanel,
+        path: '/admin-panel',
+        title: 'Admin Panel',
+        exact: true,
+        permission: [
+            Roles.ADMIN
+        ]
+    },
+    {
+        component: Workspace,
+        path: '/job-management-hub',
+        title: 'Job Management Hub',
+        exact: true,
+        permission: [
+            Roles.RECRUITER,
+        ]
+    },
+    {
+        component: ApplicationsByJobAd,
+        path: '/job-management-hub/applications/:advertisement_id',
+        title: 'Applications by Job Ad',
+        exact: true,
+        permission: [
+            Roles.RECRUITER
+        ]
+    },
+    {
+        component: ApplicationsByJobSeeker,
+        path: '/my-applications',
+        title: 'My Applications',
+        exact: true,
+        permission: [
+            Roles.JOBSEEKER
+        ]
+    },
+
+    {
+        component: JobSeekerEditProfile,
+        path: '/job-seeker/edit-profile',
+        title: 'Edit Job Seeker Profile',
+        exact: true,
+        permission: [
+            Roles.JOBSEEKER
+        ]
+    },
+    {
+        component: RecruiterEditProfile,
+        path: '/recruiter/edit-profile',
+        title: 'Edit Recruiter Profile',
+        exact: true,
+        permission: [
+            Roles.RECRUITER
+        ]
+    },
+]
+
+export const PublicRoutes = [
+    {
+        component: Dashboard,
+        path: "/",
+        exact: true,
+        permission: [
+            Roles.RECRUITER,
+            Roles.JOBSEEKER,
+            Roles.ADMIN,
+            Roles.GUEST
+        ]
+    },
+    {
+        component: SignInForm,
+        path: '/signin',
+        title: 'Sign In',
+        exact: true,
+        permission: [
+            Roles.GUEST,
+            Roles.RECRUITER,
+            Roles.JOBSEEKER,
+            Roles.ADMIN
+        ]
+    },
+
+    {
+        component: SignUpRecruiterForm,
+        path: '/signup/recruiter',
+        title: 'Sign Up as Recruiter',
+        permission: [
+            Roles.GUEST,
+            Roles.RECRUITER,
+            Roles.JOBSEEKER,
+            Roles.ADMIN
+        ]
+    },
+    {
+        component: SignUpJobSeekerForm,
+        path: '/signup/job-seeker',
+        title: 'Sign Up as Job Seeker',
+        permission: [
+            Roles.GUEST,
+            Roles.RECRUITER,
+            Roles.JOBSEEKER,
+            Roles.ADMIN
+        ]
+    },
+    {
+        component: JobAdDetails,
+        path: '/job-advertisements/:id',
+        title: 'Job Advertisement Details',
+        exact: true,
+        permission: [
+            Roles.RECRUITER,
+            Roles.JOBSEEKER,
+            Roles.ADMIN,
+            Roles.GUEST
+        ]
+    },
+    {
+        component: RecruiterProfile,
+        path: '/recruiters/:id',
+        title: 'Recruiter Profile',
+        exact: true,
+        permission: [
+            Roles.RECRUITER,
+            Roles.JOBSEEKER,
+            Roles.ADMIN,
+            Roles.GUEST
+        ]
+    },
+    {
+        component: AboutUs,
+        path: '/about',
+        title: 'About Us',
+        exact: true,
+        permission: [
+            Roles.GUEST,
+            Roles.RECRUITER,
+            Roles.JOBSEEKER,
+            Roles.ADMIN
+        ]
+    },
+]
+
+const AllRoutes = [...PrivateRoutes, ...PublicRoutes];
+
+const filterRoutes = (roleParam) => {
+    return AllRoutes.filter(route => {
+        return route.permission.includes(roleParam);
+    });
+};
+const RoutesConfig = () => {
+    const currentUser = useSelector(state => state.auth.currentUser);
+    const [role, setRole] = useState(Roles.GUEST);
+
+    useEffect(() => {
+        if (currentUser) {
+            setRole(currentUser.role);
+        }
+    }, [currentUser]);
 
     return (
-            <Routes>
-                <Route path="/" element={<Dashboard/>}></Route>
-                <Route path="/signin" element={<SignInForm/>}></Route>
-                <Route path="/signup/recruiter" element={<SignUpRecruiterForm/>}></Route>
-                <Route path="/signup/job-seeker" element={<SignUpJobSeekerForm/>}></Route>
-                <Route path="/my-job-advertisements" element={<JobAdvertisements/>}></Route>
-                <Route path="/my-applications" element={<ApplicationsByJobSeeker/>}></Route>
-                <Route path="/job-advertisements/:id" element={<JobAdDetails/>}></Route>
-                <Route path="/my-job-advertisements/:advertisement_id/applications" element={<ApplicationsByJobAd/>}></Route>
-                <Route path="/admin-panel" element={<AdminPanel/>}></Route>
-            </Routes>
+        <Routes>
+            {filterRoutes(role).map(route => (
+                <Route
+                    key={route.path}
+                    path={route.path}
+                    element={<route.component/>}
+                    exact={route.exact}
+                />
+            ))}
+            <Route path="*" element={<ErrorPage to="/"/>}/>
+        </Routes>
+
+        // <Routes>
+        //     <Route path="/" element={<Dashboard/>}></Route>
+        //     <Route path="/signin" element={<SignInForm/>}></Route>
+        //     <Route path="/signup/recruiter" element={<SignUpRecruiterForm/>}></Route>
+        //     <Route path="/signup/job-seeker" element={<SignUpJobSeekerForm/>}></Route>
+        //     <Route path="/job-management-hub" element={<Workspace/>}></Route>
+        //     <Route path="/my-applications" element={<ApplicationsByJobSeeker/>}></Route>
+        //     <Route path="/job-advertisements/:id" element={<JobAdDetails/>}></Route>
+        //     <Route path="/recruiters/:id" element={<RecruiterProfile/>}></Route>
+        //     <Route path="/job-management-hub/applications/:advertisement_id" element={<ApplicationsByJobAd/>}></Route>
+        //     <Route path="/admin-panel" element={<AdminPanel/>}></Route>
+        //     <Route path="/about" element={<AboutUs/>}></Route>
+        //     <Route path="/job-seeker/edit-profile" element={<JobSeekerEditProfile/>}></Route>
+        //     <Route path="/recruiter/edit-profile" element={<RecruiterEditProfile/>}></Route>
+        // </Routes>
     )
 }
+
+export default RoutesConfig
Index: jobvista-frontend/src/enumerations/Roles.js
===================================================================
--- jobvista-frontend/src/enumerations/Roles.js	(revision b2488107b82c95e4bdfdfd18b76b44f023786601)
+++ jobvista-frontend/src/enumerations/Roles.js	(revision befb98800bd9171fa5ce8a5f29287e549f0ff5aa)
@@ -14,3 +14,4 @@
     RECRUITER: 'ROLE_RECRUITER',
     JOBSEEKER: 'ROLE_JOBSEEKER',
+    GUEST: 'ROLE_GUEST'
 };
Index: jobvista-frontend/src/redux/actionTypes.js
===================================================================
--- jobvista-frontend/src/redux/actionTypes.js	(revision b2488107b82c95e4bdfdfd18b76b44f023786601)
+++ jobvista-frontend/src/redux/actionTypes.js	(revision befb98800bd9171fa5ce8a5f29287e549f0ff5aa)
@@ -20,4 +20,7 @@
 export const FETCH_RECRUITERS = "FETCH_RECRUITERS"
 export const CHANGE_ACCESS = "CHANGE_ACCESS"
+export const SUBMIT_RECRUITER_LOGO = "SUBMIT_RECRUITER_LOGO"
+export const SUBMIT_RECRUITER_COVER = "SUBMIT_RECRUITER_COVER"
+export const SET_LOGO_URL = 'SET_LOGO_URL';
+export const SET_PROFILE_PIC_URL = 'SET_PROFILE_PIC_URL';
 
-
Index: jobvista-frontend/src/redux/actions/applicationActions.js
===================================================================
--- jobvista-frontend/src/redux/actions/applicationActions.js	(revision b2488107b82c95e4bdfdfd18b76b44f023786601)
+++ jobvista-frontend/src/redux/actions/applicationActions.js	(revision befb98800bd9171fa5ce8a5f29287e549f0ff5aa)
@@ -47,8 +47,7 @@
       }
     },
-    fetchApplicationsByJobSeeker: (callback) => {
+    fetchApplicationsByJobSeeker: (jobSeekerId, callback) => {
       return dispatch => {
-          let currentUser = JSON.parse(localStorage.getItem(CURRENT_USER));
-          axios.get("/my-applications/" + currentUser.id)
+          axios.get("/my-applications/" + jobSeekerId)
               .then(response => {
                   dispatch({
Index: jobvista-frontend/src/redux/actions/authActions.js
===================================================================
--- jobvista-frontend/src/redux/actions/authActions.js	(revision b2488107b82c95e4bdfdfd18b76b44f023786601)
+++ jobvista-frontend/src/redux/actions/authActions.js	(revision befb98800bd9171fa5ce8a5f29287e549f0ff5aa)
@@ -45,9 +45,8 @@
                 //const refreshToken = response.refreshToken;
                 const user = {
-                    id: response.id,
-                    email: response.email,
                     name: response.name,
                     role: response.role,
                     access: response.hasAccess,
+                    id: response.id,
                 };
                 dispatch({
Index: jobvista-frontend/src/redux/actions/jobAdvertisementActions.js
===================================================================
--- jobvista-frontend/src/redux/actions/jobAdvertisementActions.js	(revision b2488107b82c95e4bdfdfd18b76b44f023786601)
+++ jobvista-frontend/src/redux/actions/jobAdvertisementActions.js	(revision befb98800bd9171fa5ce8a5f29287e549f0ff5aa)
@@ -87,8 +87,8 @@
     },
 
-    fetchJobAdvertisementsByRecruiter: (callback) => {
+    fetchJobAdvertisementsByRecruiter: (recruiterId, callback) => {
         return dispatch => {
             let currentUser = JSON.parse(localStorage.getItem(CURRENT_USER));
-            axios.get("/job-advertisements/recruiter/" + currentUser.id)
+            axios.get("/job-advertisements/recruiter/" + recruiterId)
                 .then(response => {
                     dispatch({
@@ -103,8 +103,8 @@
     },
 
-    filterJobAdvertisementsByRecruiter: (filter, callback) => {
+    filterJobAdvertisementsByRecruiter: (id, filter, callback) => {
 
         let currentUser = JSON.parse(localStorage.getItem(CURRENT_USER));
-        axios.post("/job-advertisements/recruiter/" + currentUser.id + "/filtered", filter)
+        axios.post("/job-advertisements/recruiter/" + id + "/filtered", filter)
             .then(response => {
                 callback(true, response)
@@ -116,5 +116,5 @@
 
     fetchRecruiterDetailsById: (id, callback) => {
-        axios.get("/recruiter/info/" + id)
+        axios.get("/recruiter/"+id+"/info")
             .then(response => {
                 callback(true, response)
Index: jobvista-frontend/src/redux/reducers/authReducer.js
===================================================================
--- jobvista-frontend/src/redux/reducers/authReducer.js	(revision b2488107b82c95e4bdfdfd18b76b44f023786601)
+++ jobvista-frontend/src/redux/reducers/authReducer.js	(revision befb98800bd9171fa5ce8a5f29287e549f0ff5aa)
@@ -3,4 +3,5 @@
 import {isExpired} from "react-jwt";
 import {CURRENT_USER, SIGN_IN, SIGN_OUT, UPDATE_TOKEN} from "../actionTypes";
+import {jwtDecode} from "jwt-decode";
 
 const initialState = {
@@ -13,5 +14,5 @@
         case SIGN_IN:
             localStorage.setItem(AUTH_TOKEN, action.payload.token);
-            localStorage.setItem(CURRENT_USER, JSON.stringify(action.payload.user));
+            //localStorage.setItem(CURRENT_USER, JSON.stringify(action.payload.user));
             return {
                 ...state,
@@ -21,10 +22,24 @@
         case UPDATE_TOKEN:
             let token = action.payload;
+            let decodedToken;
             let currentUser = "";
+            if(token !=null) {
+                try {
+                    decodedToken = jwtDecode(token);
+                } catch (error) {
+                    console.log("Failed to decode token: " + error)
+                }
+            }
+
             if(!isExpired(token)) {
                 localStorage.setItem(AUTH_TOKEN, token);
-                currentUser = JSON.parse(localStorage.getItem(CURRENT_USER));
+                currentUser = {
+                    name: decodedToken.name,
+                    role: decodedToken.role,
+                    access: decodedToken.access,
+                    id: decodedToken.id
+                };
             } else {
-                localStorage.removeItem(CURRENT_USER);
+                //localStorage.removeItem(CURRENT_USER);
                 localStorage.removeItem(AUTH_TOKEN);
                 currentUser = "";
@@ -37,5 +52,5 @@
             };
         case SIGN_OUT:
-            localStorage.removeItem(CURRENT_USER);
+            //localStorage.removeItem(CURRENT_USER);
             localStorage.removeItem(AUTH_TOKEN);
             return {
Index: jobvista-frontend/src/redux/reducers/jobAdvertisementReducer.js
===================================================================
--- jobvista-frontend/src/redux/reducers/jobAdvertisementReducer.js	(revision b2488107b82c95e4bdfdfd18b76b44f023786601)
+++ jobvista-frontend/src/redux/reducers/jobAdvertisementReducer.js	(revision befb98800bd9171fa5ce8a5f29287e549f0ff5aa)
@@ -1,7 +1,12 @@
 import {
     ADD_JOB_ADVERTISEMENT,
-    CURRENT_USER, DELETE_JOB_ADVERTISEMENT, EDIT_JOB_ADVERTISEMENT,
+    CURRENT_USER,
+    DELETE_JOB_ADVERTISEMENT,
+    EDIT_JOB_ADVERTISEMENT,
     FETCH_JOB_ADVERTISEMENTS,
-    FETCH_JOB_ADVERTISEMENTS_BY_RECRUITER, FILTER_JOB_ADVERTISEMENTS, FILTER_JOB_ADVERTISEMENTS_BY_RECRUITER
+    FETCH_JOB_ADVERTISEMENTS_BY_RECRUITER,
+    FILTER_JOB_ADVERTISEMENTS,
+    FILTER_JOB_ADVERTISEMENTS_BY_RECRUITER,
+    SET_LOGO_URL
 } from "../actionTypes";
 import {sortElementsBy} from "../../utils/utils";
Index: jobvista-frontend/src/redux/store.js
===================================================================
--- jobvista-frontend/src/redux/store.js	(revision b2488107b82c95e4bdfdfd18b76b44f023786601)
+++ jobvista-frontend/src/redux/store.js	(revision befb98800bd9171fa5ce8a5f29287e549f0ff5aa)
@@ -6,4 +6,5 @@
 import adminReducer from "./reducers/adminReducer"
 import {AdminActions} from "./actions/adminActions";
+import ImagesReducer from "./reducers/imagesReducer";
 
 // const rootReducer = combineReducers({
@@ -21,5 +22,6 @@
         jobAd: jobAdReducer,
         appl: applicationReducer,
-        admin: adminReducer
+        admin: adminReducer,
+        images: ImagesReducer
     },
 });
Index: jobvista-frontend/src/views/admin_panel/AdminPanel.js
===================================================================
--- jobvista-frontend/src/views/admin_panel/AdminPanel.js	(revision b2488107b82c95e4bdfdfd18b76b44f023786601)
+++ jobvista-frontend/src/views/admin_panel/AdminPanel.js	(revision befb98800bd9171fa5ce8a5f29287e549f0ff5aa)
@@ -4,4 +4,5 @@
 import {useState, useEffect} from "react";
 import {AdminActions} from "../../redux/actions/adminActions";
+import {notifyAccessUpdate} from "../../utils/toastUtils";
 
 export const AdminPanel = () => {
@@ -24,4 +25,6 @@
             setRecruiters(recruitersState)
             console.log("Fetch all recruiters STATE")
+            console.log(recruitersState)
+
         }
     }, [recruitersState])
@@ -32,5 +35,6 @@
     };
 
-    const handleAccessChange = (recruiterId, newAccessStatus) => {
+    const handleAccessChange = (recruiterId, companyName, newAccessStatus) => {
+
         setRecruiters(prevState =>
             prevState.map(recruiter =>
@@ -41,9 +45,7 @@
         );
 
-        console.log(recruiterId + " " + newAccessStatus)
-
         dispatch(AdminActions.changeAccess(recruiterId, newAccessStatus, (success, response) => {
             if(success) {
-                console.log("Access changed")
+                notifyAccessUpdate(companyName)
             }
         }));
@@ -51,5 +53,5 @@
 
     return (
-        <div className="applications-container mt-5">
+        <div className="custom-container mt-5">
             <table className="table table-striped">
                 <thead>
@@ -64,5 +66,5 @@
                 </thead>
                 <tbody>
-                {recruiters.map((recruiter) => (
+                {recruitersState.map((recruiter) => (
                     <tr key={recruiter.id}>
                         <th scope="row">{recruiter.id}</th>
@@ -70,5 +72,5 @@
                         <td>{recruiter.email}</td>
                         <td>{recruiter.companyName}</td>
-                        <td>{recruiter.phoneNumber}</td>
+                        <td>{recruiter.contactPhoneNumber}</td>
                         <td>
                             <label className="switch">
@@ -76,5 +78,5 @@
                                     type="checkbox"
                                     checked={recruiter.hasAccess}
-                                    onChange={(e) => handleAccessChange(recruiter.id, e.target.checked)}
+                                    onChange={(e) => handleAccessChange(recruiter.id, recruiter.companyName, e.target.checked)}
                                 />
                                 <span className="slider"></span>
Index: jobvista-frontend/src/views/applications/ApplicationDetailsModal.js
===================================================================
--- jobvista-frontend/src/views/applications/ApplicationDetailsModal.js	(revision befb98800bd9171fa5ce8a5f29287e549f0ff5aa)
+++ jobvista-frontend/src/views/applications/ApplicationDetailsModal.js	(revision befb98800bd9171fa5ce8a5f29287e549f0ff5aa)
@@ -0,0 +1,84 @@
+import React, {useEffect, useState} from "react";
+import "../shared_css/Modal.css";
+
+import 'react-responsive-modal/styles.css';
+import {Modal} from 'react-responsive-modal';
+import Select from "react-select";
+
+//Validation
+import * as yup from "yup";
+import {yupResolver} from "@hookform/resolvers/yup";
+import {Controller, useForm} from "react-hook-form";
+
+
+import {employmentStatusOptions, industryOptions, jobTypeOptions} from "../selectOptions";
+import {useDispatch, useSelector} from "react-redux";
+import {JobAdvertisementActions} from "../../redux/actions/jobAdvertisementActions";
+import Roles from "../../enumerations/Roles";
+import {ApplicationActions} from "../../redux/actions/applicationActions";
+
+
+export const ApplicationDetailsModal = (props) => {
+    const {application} = props
+    const [modal, setModal] = useState(false);
+    const dispatch = useDispatch();
+    const auth = useSelector(state => state.auth.currentUser)
+    const [resumeUrl, setResumeUrl] = useState("");
+
+    //const [resumeFile, setResumeFile] = useState(null);
+    const toggleModal = () => {
+        setModal(!modal);
+    };
+
+    useEffect(() => {
+        if(application) {
+            dispatch(ApplicationActions.downloadResume(application.fileName, (success, response) => {
+                if(success) {
+                    setResumeUrl(response);
+                }
+            }))
+        }
+    }, [application])
+
+    return (<div className="modal-wrap">
+        <button onClick={toggleModal} className="application-button">View application</button>
+        <Modal open={modal} onClose={toggleModal} center >
+            <div className="head-modal">
+                <h3>{application.jobSeekerName}'s application for {application.jobAdTitle}</h3>
+                <i className="fa-solid fa-x btn-close-modal" onClick={toggleModal}></i>
+            </div>
+
+            <div className="modal-content" >
+                <form>
+                    <div className="row">
+                        <div className="col-md-6">
+                            <label className="label">Why are you interested in joining our company?</label>
+                            <textarea disabled type="text" defaultValue={application.questionAnswers[0]} disabled placeholder="Write your answer here..." className="application-textarea"/>
+
+
+                            <label className="label">What makes you a good fit for this position?</label>
+                            <textarea disabled type="text" defaultValue={application.questionAnswers[1]}  placeholder="Write your answer here..." className="application-textarea"/>
+
+
+                            <label className="label">What do you hope to achieve in your first 6 months in this role?</label>
+                            <textarea disabled type="text" defaultValue={application.questionAnswers[2]}  placeholder="Write your answer here..." className="application-textarea"/>
+
+                        </div>
+                        <div className="col-md-6">
+                            <label htmlFor="start">Curriculum vitae (CV)</label>
+                            <br/>
+                            <a className="resume-link" href={resumeUrl} target="_blank" rel="noopener noreferrer">{application.fileName}</a>
+                            <br/>
+
+                            <br/>
+                            <label className="label">Message to the recruiter</label>
+                            <textarea disabled type="text" defaultValue={application.message} placeholder="Optional..." className="application-textarea"/>
+
+                        </div>
+                    </div>
+
+                </form>
+            </div>
+        </Modal>
+    </div>)
+}
Index: jobvista-frontend/src/views/applications/ApplicationsByJobAd.js
===================================================================
--- jobvista-frontend/src/views/applications/ApplicationsByJobAd.js	(revision b2488107b82c95e4bdfdfd18b76b44f023786601)
+++ jobvista-frontend/src/views/applications/ApplicationsByJobAd.js	(revision befb98800bd9171fa5ce8a5f29287e549f0ff5aa)
@@ -1,9 +1,12 @@
-import {useDispatch} from "react-redux";
+import {useDispatch, useSelector} from "react-redux";
 import {useEffect, useState} from "react";
 import {useParams} from "react-router";
 import {ApplicationActions} from "../../redux/actions/applicationActions";
-import {ViewApplicationDetails} from "./ViewApplicationDetails";
+import {ApplicationDetailsModal} from "./ApplicationDetailsModal";
 import "./Applications.css"
 import Select from "react-select";
+import {sortElementsBy} from "../../utils/utils";
+import {JobSeekerActions} from "../../redux/actions/JobSeekerActions";
+import {notifyAppStatusUpdate} from "../../utils/toastUtils";
 
 export const ApplicationsByJobAd = () => {
@@ -11,15 +14,58 @@
     const dispatch = useDispatch();
     let {advertisement_id} = useParams();
+
     const [applicationsByJobAd, setApplicationsByJobAd] = useState([]);
+    let applicationsByJobAdState = useSelector(state => state.appl.applicationsByJobAdId)
+    const [dispatched, setDispatched] = useState(false);
+
+    const [profilePics, setProfilePics] = useState({});
+    let profilePicsState = useSelector(state => state.images.profilePictures)
+    const [profilePicsDispatched, setProfilePicsDispatched] = useState(false);
+
     const [jobAdTitle, setJobAdTitle] = useState("");
 
     useEffect(() => {
-        dispatch(ApplicationActions.fetchApplicationsByJobAdId(advertisement_id, (success, reponse) => {
-            if (success && reponse.data.length > 0) {
-                setApplicationsByJobAd(reponse.data)
-                setJobAdTitle(reponse.data[0].jobAdTitle)
+        if(!dispatched && (applicationsByJobAdState.length === 0 || applicationsByJobAdState.length === 1)) {
+            dispatch(ApplicationActions.fetchApplicationsByJobAdId(advertisement_id, (success, reponse) => {
+                if (success && reponse.data.length > 0) {
+                    setApplicationsByJobAd(sortElementsBy(reponse.data, "submittedOn"))
+                    setJobAdTitle(reponse.data[0].jobAdTitle)
+                }
+                setDispatched(true)
+                console.log("Fetch applications by job ad GET")
+            }))
+        } else {
+            setApplicationsByJobAd(sortElementsBy(applicationsByJobAdState, "submittedOn"));
+            if(applicationsByJobAdState.length > 0) {
+                setJobAdTitle(applicationsByJobAdState[0].jobAdTitle)
+            }
+
+        }
+
+    }, [applicationsByJobAdState])
+
+    useEffect(() => {
+        if(dispatched && !profilePicsDispatched) {
+            applicationsByJobAd.forEach(app => {
+                if(app.jobSeekerId && !profilePics[app.jobSeekerId]) {
+                    fetchProfilePic(app.jobSeekerId)
+                }
+            })
+            setProfilePicsDispatched(true);
+            console.log("Fetch all profile pics GET")
+        } else if(profilePicsDispatched) {
+            setProfilePics(profilePicsState)
+            console.log("Fetch all profile pics STATE")
+        }
+    }, [dispatched])
+
+    const fetchProfilePic = (jobSeekerId) => {
+        dispatch(JobSeekerActions.downloadProfilePic(jobSeekerId, (success, response) => {
+            if(success) {
+                setProfilePics(prevState => ({...prevState, [jobSeekerId]: response}))
             }
         }))
-    }, [])
+    }
+
 
     const options = [
@@ -37,5 +83,6 @@
         dispatch(ApplicationActions.updateApplicationStatus(id, selectedOption.value, (success, response) => {
             if(success) {
-                console.log("Status updated.")
+                // console.log("Status updated.")
+                notifyAppStatusUpdate()
             }
         }))
@@ -43,16 +90,23 @@
 
 
-    return (<div className="applications-container">
+    return (<div className="custom-container">
         <div className="application-title">
             {jobAdTitle ?
-                <h1>Applications for <span>{jobAdTitle}</span></h1> :
+                <h3>Applications for <b>{jobAdTitle}</b></h3> :
                 <h1></h1>
             }
-
         </div>
 
         {applicationsByJobAd && applicationsByJobAd.map((application, index) => (
             <div className="application-card">
-                <div className="left-box">
+                <div className="app-job-seeker-pic">
+                    <img
+                        // loading gif
+                        src={profilePicsState[application.jobSeekerId]}
+                        alt=""
+                        width={75} height={75}
+                    />
+                </div>
+                <div className="app-info">
                     <span>Submitted on <b>{new Date(application.submittedOn).toLocaleString('default', {
                         day: 'numeric',
@@ -60,13 +114,10 @@
                         year: 'numeric'
                     })}</b></span>
-                    <br/><br/>
                     <div className="contact-info">
                         <div className="contact-item">
                             <i className="fa-solid fa-user"></i> <span>{application.jobSeekerName}</span>
-                        </div>
-                        <div className="contact-item">
+                        </div> <div className="contact-item">
                             <i className="fa-solid fa-envelope"></i> <span>{application.jobSeekerEmail}</span>
-                        </div>
-                        <div className="contact-item">
+                        </div> <div className="contact-item">
                             <i className="fa-solid fa-phone"></i> <span>{application.jobSeekerPhoneNumber}</span>
                         </div>
@@ -74,6 +125,6 @@
                 </div>
 
-                <div className="right-box">
-                    <ViewApplicationDetails application={application}/>
+                <div className="app-status">
+                    <ApplicationDetailsModal application={application}/>
                     <div className="select">
                         <Select options={options}  onChange={(selectedOption) => handleChangeStatus(selectedOption, application.id)} defaultValue={handleDefaultStatus(application.status)}/>
